#
# ZtoP
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Author: Mike Webb <finlaugh@home.com>
# This software is ZPL  ( I think that is the right mumbojumbo :)  )
#
# Have fun with it, dont yell at me too loud when you hate it!
# If you have any ideas I would love to hear them!

from cStringIO import StringIO
from Globals import HTMLFile
from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from Acquisition import Implicit
from Globals import Persistent
from AccessControl.Role import RoleManager
from OFS.ObjectManager import ObjectManager
from OFS.SimpleItem import Item
from OFS.PropertyManager import PropertyManager
import string

def getExtensionMapping(self):
   """this will return a map of all the classes needed for the particular ZClass"""
   ob = self
   a=""
   extensionsDict={}
   for each in ob._zbases:
      if hasattr(each,'_zclass_'):
         tempList=[]
         listX=string.split(str(each._zclass_))
         if(len(listX)<2):
            tempList=string.split(listX[0],'.')
         else:
            tempList=string.split(listX[2],'.')         
         clazz=tempList[len(tempList)-1]
         importz=string.join(tempList[0:(len(tempList)-1)],'.')
         extensionsDict[clazz]="from "+importz+" import "+clazz+"#Extension templates"
   return extensionsDict


manage_addZtoPForm = HTMLFile('dtml/select_zclass', globals())

def manage_addZtoP(self, id, zclass, REQUEST=None):
    """Add a ZtoP"""
    p=ZtoP(id, zclass,REQUEST)
    self._setObject(id, p)
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)

class ZtoP(Implicit,Persistent, RoleManager, ObjectManager, Item, PropertyManager):
   """This is the base LMS Class"""
    
   meta_type='ZtoP'
   
   security=ClassSecurityInfo()

   def __init__(self, id, zclass, REQUEST=None):
      self.id=id
      self.title=""
      self.template_maps=[]
      self.product=string.split(zclass,'\\')[0]
      self.zclass=string.split(zclass,'\\')[1]
      self.securityDict={}
      
   _properties=({'id':'title','type':'string','mode':'w'},
		{'id':'template_maps','type':'lines','mode':'w'},
               )

   class_py = HTMLFile('dtml/class_py', globals())
   sec = HTMLFile('dtml/sec', globals())
   init_py = HTMLFile('dtml/init_py', globals())
   py_template = HTMLFile('dtml/py_template', globals())
   dtml_template = HTMLFile('dtml/dtml_template', globals())
   manage_workspace = HTMLFile('dtml/edit_zclass', globals())
   sql_template = HTMLFile('dtml/sql_template', globals())
   init = HTMLFile('dtml/init',globals())

   manage_workspacez = HTMLFile('dtml/pmain', globals()) # Management Interface
   manage_properties = HTMLFile('dtml/pproperties', globals()) # Management Interface 
   manage_options = (
                     {'label': 'Step 1: Select ZClass', 'action': 'manage_workspace'},
                     {'label': 'Step 2: Set Method Securities', 'action': 'secWrp'},
                     {'label': 'Step 3: Build Classfile', 'action': 'build_python_file'},
                     {'label': 'Step 4: Get the code', 'action': 'manage_workspacez'},
                     {'label': 'Properties/Template Map', 'action': 'manage_properties'},
                    )
         
   security.declareProtected('Use ZtoP','secWrp')         
   def build_python_file(self):
       """this is the build"""
       class_ob = self.REQUEST.PARENTS[-1].Control_Panel.Products[self.product][self.zclass]
       ##The following lines are messy, because they temporarily create the object to get
       ##the management options.  Have not found a better way to get the views yet.
       class_m_options=""
       try:
          i=class_ob.createInObjectManager('ZtoP_temporary_instance', self.REQUEST)
          class_m_options = ""
          class_m_options = "(\n"
          for each in i.manage_options:
             if(each.has_key('filter')):
                del each['filter']
             class_m_options = class_m_options+"                   "+str(each)+",\n"
          class_m_options = class_m_options+"                  )\n"
          class_ob.aq_parent.manage_delObjects(['ZtoP_temporary_instance'])
       except:
	  class_m_options="""(
        (ObjectManager.manage_options[0],)+
        (
        {'label':'View', 'action':'index_html')},
        )+
        PropertyManager.manage_options+
        RoleManager.manage_options+
        Item.manage_options)"""
       ##End of that ugliness
       inheritence_List="Implicit,Persistent, RoleManager, Item, PropertyManager"
       imports={}
       ob = self.REQUEST.PARENTS[-1].Control_Panel.Products[self.product][self.zclass]
       extensionsDict = getExtensionMapping(ob)
       for each in extensionsDict.keys():
          if each not in imports.keys():
             if(each=='Folder'):
                imports['ObjectManager']="from OFS.ObjectManager import ObjectManager\n";
             else:
                imports[each]=extensionsDict[each]+"\n"
       inheritence_List=string.join(imports.keys(),',')+","+inheritence_List
       templte = self.registerTemplates()
       self.REQUEST.RESPONSE.appendHeader('Content-Type','text/plain')       
       result_class=self.class_py(class_ob,self.REQUEST, class_m_options=class_m_options,\
                                  inheritence_List=inheritence_List,imports=imports,\
                                  templte=templte,securityDict=self.securityDict)
       result_init=self.init_py(class_ob,self.REQUEST,product=self.zclass+"_product")
       if(self.zclass+"_product" in self.objectIds()):
          self.manage_delObjects([self.zclass+"_product"])
       self.manage_addFolder(self.zclass+"_product", 'ZClass to Product')
       self[self.zclass+"_product"].manage_addFolder('dtml', 'DTML Methods')
       self[self.zclass+"_product"].manage_addProduct['OFSP'].manage_addFile(self.zclass+".py",StringIO(result_class),"Class file","","text/plain")
       self[self.zclass+"_product"].manage_addProduct['OFSP'].manage_addFile("init__.py",StringIO(result_init),"Init file.. rename to __init__.py","","text/plain")
       url=self.REQUEST['URL1']
       self.REQUEST.RESPONSE.redirect(url+"/manage_workspacez")

   security.declareProtected('Use ZtoP','secWrp')         
   def secWrp(self):
       """this is the build"""
       class_ob = self.REQUEST.PARENTS[-1].Control_Panel.Products[self.product][self.zclass]
       return self.sec(self,self.REQUEST,orig=class_ob,clazz=self.zclass,securityDict=self.securityDict)

   def manage_editZtoP(self, zclass, REQUEST=None):
      """This handles a ZClass Change"""
      self.product=string.split(zclass,'\\')[0]
      self.zclass=string.split(zclass,'\\')[1]
      self.product=self.product
      self.zclass=self.zclass
      url=self.REQUEST['URL1']
      self.REQUEST.RESPONSE.redirect(url+"/secWrp")

   def log_securities(self,sec):
      """This registers the security settings"""
      self.securityDict={}
      for each in sec:
         self.securityDict[each.name]={'option':each.option}
         self.securityDict[each.name]['permission']=getattr(each,'permission',"")
         self.securityDict=self.securityDict
      url=self.REQUEST['HTTP_REFERER']
      self.REQUEST.RESPONSE.redirect(url)
         
   def registerTemplates(self):
      """This registers all user added templates"""
      templte={}
      templte={'Script (Python)':self.py_templateFunc}
      templte['DTML Method']=self.dtml_templateFunc
      templte['Z SQL Method']=self.sql_templateFunc
      for each in self.template_maps:
         temp_list=string.split(each,',')
         if(hasattr(self,temp_list[0])):
            templte[temp_list[0]]=getattr(self,temp_list[1])
      return templte

   def py_templateFunc(self,ob):
        args=""
        if(not ob.params()==""):
            args=","+ob.params()
        tempBodyList=string.split(ob.body(),"\n")
        tempBodyString=""
        for each in tempBodyList:
           tempBodyString=tempBodyString+"      "+each+"\n"            
        return self.py_template(self,{'name':ob.getId(),'args':args,'body':tempBodyString,'docstring':ob.title_or_id()})+"\n"

   def dtml_templateFunc(self,ob):
        return self.dtml_template(self,{'name':ob.getId()})+"\n"

   def sql_templateFunc(self,ob):
        conn=str(ob.SQLConnectionIDs()[0])
        tempBodyList=string.split(ob.src,"\n")
        tempBodyString=""
        for each in tempBodyList:
           tempBodyString=tempBodyString+"         "+each+"\n"            
        return self.sql_template(self,{'name':ob.getId(),
                                            'args':ob.arguments_src,
                                            'src':tempBodyString,
                                            'conn':conn,
                                            'docstring':ob.title_or_id()
                                          })+"\n"                                          



InitializeClass(ZtoP)  